# Contributing to Ergo Framework

Anybody willing to contribute to the project either with code, documentation, security reviews or whatever, are very 
welcome to create or review pull requests and take part in discussions in any of our public [Discord community](https://discord.gg/sdscxKGV62), 
[Telegram group](https://t.me/ergo_services) or [GitHub Discussions](https://github.com/ergo-services/ergo/discussions)

## License

```txt
By making a contribution to this project, I certify that:

(a) The contribution was created in whole or in part by me and I
    have the right to submit it under the open source license
    indicated in the file; or

(b) The contribution is based upon previous work that, to the 
    best of my knowledge, is covered under an appropriate open 
    source license and I have the right under that license to   
    submit that work with modifications, whether created in whole
    or in part by me, under the same open source license (unless
    I am permitted to submit under a different license), as 
    Indicated in the file; or

(c) The contribution was provided directly to me by some other
    person who certified (a), (b) or (c) and I have not modified
    it.

(d) I understand and agree that this project and the contribution
    are public and that a record of the contribution (including 
    all personal information I submit with it, including my
    sign-off) is maintained indefinitely and may be redistributed
    consistent with this project or the open source license(s)
    involved.
```
See [https://cla-assistant.io/ergo-services/ergo](https://cla-assistant.io/ergo-services/ergo) for a copy of the Developer Certificate of Origin license.

Ergo Framework is licensed under the MIT License, as stated in [LICENSE](LICENSE) file.

## Reporting a bug or a feature request

Report bugs at https://github.com/ergo-services/ergo/issues

If you've found a **bug** or have a **feature request** then please create an issue in this repository (but search first in case a similar issue already exists).

## Submitting Pull Requests

You can contribute to Ergo Framework by opening a Pull Request. If you would like to fix a bug or 
implement a feature, please fork the repository and create a Pull Request. 

Before you start any Pull Request, it's recommended that you create an issue to discuss first if you have any doubts about requirement or implementation.
That way you can be sure that the maintainer(s) agree on what to change and how, and you can hopefully get a quick merge afterwards.
Also, let the maintainers know that you plan to work on a particular issue so that no one else starts any duplicate work.

In most cases, pull requests for new features should be based on the `master` branch.

Make sure that your feature does not break backward compatibility. In general, we only break backward
compatibility in major releases and only for a very good reason.

## Collaboration with maintainers

Sometimes the codebase can be a challenge to navigate, especially for a first-time contributor. We don't want you 
spending an hour trying to work out something that would take us only a minute to explain.
